{
  Diese Unit wurde fr ein NC-hnliches Dateiverwaltungs-Programm entwickelt.
  Dieses wurde leider nie fertiggestellt. Diese Unit enthlt Routinen, um den
  Inhalt eines RAR-Archives in eine Struktur einzulesen.
}

unit arcview;

interface
  Procedure Init_arcview(me, se, s, f, a, d: pointer);
    {Pointer auf die Variablen max_entry, scroll_entry, size, files,
   type_of_archive, directories }

  Procedure Look_rar_archive(arcname : string;start_of_header: longint);

  Procedure look_rar_dir(arcdir:string);

implementation
{$p+}
uses crt, dos;

type
  file_type     =       record
                          name   : string[12];   { file name }
                          suf    : string[3];    { file suffix }
                          attrib : word;         { file attrib }
                          date   : datetime;     { file date and time }
                          p_size : longint;      { packed size }
                          u_size : longint;      { unpacked size }
                          to_cont: boolean;      { volume: file to be continued ? }
                          cont   : boolean;      { volume: file began elsewhere ? }
                          dirnbr : word;         { fictive directory number of archived file }
                        end;

  xy            =       array [0..511] of file_type;
  dirptr1       =       ^string;

var
  max_entry     :       ^integer;
  scroll_entry  :       ^integer;
  size          :       ^longint;
  files         :       ^xy;
  int_files     :       ^xy; { unit-internal list of files ... }
  type_of_archive:      ^byte;
  directories   :       ^word;
  fn             :       file;
  p1             :       array [0..2043] of dirptr1;

Procedure Init_arcview(me, se, s, f, a,d: pointer);
begin;
  max_entry:=me;
  scroll_entry:=se;
  size:=s;
  type_of_archive:=a;
  files:=f;
  directories:=d;
end;

Procedure Look_rar_dir(arcdir:string);
var
  i:longint;
  i2:longint;
  i3:word;
begin;
  i3:=1;
  for i:=0 to directories^ do begin;
    { search the number of the directorie... }
    if p1[i]^=arcdir then begin;
      { ... and search all files matching this number }
      for i2:=0 to max_entry^ do begin;
        if int_files^[i2].dirnbr=i then begin;
          files^[i3].name:=int_files^[i2].name;
          files^[i3].suf:=int_files^[i2].suf;
          inc(i3);
        end;
      end;
    end;
  end;
end;

Procedure Look_rar_archive(arcname : string;start_of_header: longint);
          { Variable 'start_of_header' needed because of the ability to look
            into RAR self-extracting files... , otherwise = 0 }
{$i-}
label label1;
var
  pos           :       longint;        { position inside the archive }
  output        :       string;
  i             :       longint;
  i2            :       longint;
  i3            :       longint;
  i4            :       longint;
  buf1          :       array [0..7] of byte;
  buf2          :       string;
  buf3          :       array [0..$99] of byte;
  csize         :       longint;
  arcdir        :       string;
  file_counter  :       word;
begin;
  assign(fn, arcname); reset(fn,1);
  file_counter:=0;
  i:=ioresult;
  if i<>0 then begin;
    gotoxy(1,1);
    case i of
      2 : write('file not found : ', arcname);
    end;
    exit;
  end;
  type_of_archive^:=1; pos:=start_of_header; directories^:=0; size^:=$0000;
  max_entry^:=1; scroll_entry^:=0; size^:=0;
  int_files^[0].name:='..'; int_files^[0].attrib:=$10; i:=1; p1[0]^:='';
  repeat;
    seek(fn,pos);
    blockread(fn,buf1,$07);
    inc(pos,buf1[$05]+longint(buf1[$06])*$100);
    case buf1[$02] of
      { Main header }
      $73 : begin;
        int_files^[i].attrib:=buf1[$03];
        if buf1[$03] and $80 <> 0 then begin;
          blockread(fn,buf3,4);
          inc(pos,buf3[0]+longint(buf3[1])*$100+longint(buf3[2])*$10000
                            +longint(buf3[3])*$1000000);
        end;
      end;
      { lokal File header }
      $74 : begin;
        int_files^[i].attrib:=longint(buf1[$03])*$100;
        blockread(fn,buf3,$18);
        inc(pos,buf3[0]+longint(buf3[1])*$100+longint(buf3[2])*$10000+longint(buf3[3])*$1000000);
        inc(size,buf3[4]+longint(buf3[5])*$100+longint(buf3[6])*$10000+longint(buf3[7])*$1000000);
        int_files^[i].attrib:=int_files^[i].attrib+buf3[$15]+longint(buf3[$16])*$100;
        csize:= longint(buf3[$14])*$100+buf3[$13];
        blockread(fn, buf2, succ(csize));
        buf2[0]:=chr(csize);
        { Directory ? if so, put it into the directory list ... }
        if int_files^[i].attrib and $10 <> 0 then begin;
          inc(directories^);
          getmem(p1[directories^],length(buf2));
          p1[directories^]^:=buf2;
          writeln(buf2);
        end;
        if int_files^[i].attrib and $10 = 0 then begin;
          { No Directory ? if so, put it into the file list ... }
          i2:=csize;
          { search begin of filename ... }
          while ((i2<>0)and(buf2[i2]<>'\')) do dec(i2);
          { ... search the directory number ... }
          if i2<>0 then begin;
            inc(i2);
            i3:=0;
            while ((i3<>directories^)and(int_files^[i].dirnbr<>i3)) do begin;
              i4:=length(p1[i3]^);
              while ((i4<>0)and(p1[i3]^[i4]=buf2[i4])) do dec(i4);
              if i4=0 then int_files^[i].dirnbr:=i3;
              inc(i3);
            end;
          end else int_files^[i].dirnbr:=0;
          writeln(int_files^[i].dirnbr);
          { ... and trunc directory name }
          if i2<>0 then int_files^[i].name:=copy(buf2,i2,length(buf2)-i2) else int_files^[i].name:=buf2;
          {writeln(i,': ',int_files^[i].name,'  ',int_files^[i].suf,'  ',int_files^[i].dirnbr);}
          inc(i);
          inc(file_counter);
        end;
        inc(max_entry^);
      end;
    end;
  until pos>=filesize(fn);
  { No Capital file names...}
  for i3:=0 to file_counter do begin;
    {if int_files^[i3].attrib and $10 <> $10 then}
    for i2:=1 to length(int_files^[i3].name) do
      if ord(int_files^[i3].name[i2])>$40 then
        if ord(int_files^[i3].name[i2])<$5b then
         int_files^[i3].name[i2]:=chr(ord(int_files^[i3].name[i2])+$20);
  end;
  { divide into name and suffix... }
  for i:=0 to file_counter do begin;
    if int_files^[i].name[1]<>'.' then begin;
      i2:=1;
      repeat;
        if int_files^[i].name[i2]='.' then begin;
          int_files^[i].suf:=copy(int_files^[i].name,i2+1,length(int_files^[i].name)-1);
          int_files^[i].name:=copy(int_files^[i].name,1,i2-1);
        end;
        inc(i2);
      until((i2>length(int_files^[i].name))or(int_files^[i].name[i2-1]='.'));
      if int_files^[i].name[i2-1]<>'.' then int_files^[i].suf:='';
    end;
  end;
  { Clear useless entries }
  if max_entry^ < 56 then for i:=max_entry^ to 56 do begin;
    int_files^[i].name:='';
    int_files^[i].suf:='';
  end;
  { Close file and leave unit}
  close(fn);
end;

end.
