{$q-}

uses crt, dos;
type
  feld = array [0..63999] of byte;

var
  i : word;
  zw : word;
  i2 : word;
  p : ^feld;
  f : file;
  xf, yf, zf : boolean;
  hour, minute, sec, sec100 : word;
  hour2, minute2, sec2, sec1002 : word;
  time : word;
  zoom : integer;
  x  :  integer;
  y  :  integer;
  d  :  integer;

Procedure WaitRetrace; assembler;
asm
  mov dx,$3da
  @x: in al, dx
      test al, 08h
      jnz @x
  @y: in al, dx
    test al, 08h
    jz @y
end;

Procedure SetCol(col, r, g, b:byte); Assembler;
asm
  mov dx, $3c8
  mov al, col
  out dx, al

  mov dx, $3c9
  mov al, r
  out dx, al

  mov al, g
  out dx, al

  mov al, b
  out dx, al
end;

procedure setpal;
begin;
  for i:=0 to 255 do setcol(i, p^[i*4+2] div 4, p^[i*4+1] div 4, p^[i*4] div 4);
end;

procedure buildscreen(z:integer; x, y : integer; d:integer);
var
  xkonstante : integer;
  screen_x_move : integer;
  screen_y_move : integer;
  pic_x_move : integer;
  pic_y_move : integer;
begin;
    if z = -128 then exit;
    pic_y_move:=y*256;
    pic_x_move:=x;
    screen_x_move:=160-(319 div 2);
    screen_y_move:=(100-(199 div 2))*320;
    xkonstante:=-screen_x_move
		-screen_y_move-3;
    inc(xkonstante, 319 mod 4+d);

  asm;
    cld
    push ds

    mov ax, z
    add ax, 128
    push ax
    db 0fh, 0a9h			{ Pop GS }
    mov si, word ptr p                  { DS:SI -> Bitmap }
    mov ds, word ptr (p+2)
    push $a000
    pop es
    xor di, di

    mov bx, 199                          { BX=Y }
    call waitretrace
  @YLoop:                               { CX=X }
    mov cx, 320
    { Berechnung des 'Y1-Wertes' des Bildes}
    db 08ch, 0e8h			{ mov ax, gs }
    mul bx
    { Multiplizieren mit Bildbreite und in Y ablegen}
    shl ax, 1
    and ax, 1111111100000000b
    { Bildverschiebung }
    add ax, pic_y_move
    push ax
    db 0fh, 0a1h			{ Pop FS }

    { horizontal Zentrieren }
    mov ax, di
    add di, screen_x_move
    add di, screen_y_move

  @XLoop:
    { Berechnung des 'X1-Offsettes' }
    db 08ch, 0e8h			{ mov ax, gs }
    mul cx
    shr ax, 7
    add ax, pic_x_move

    db 08ch, 0e6h			{ mov si, fs }
    add si, ax

    movsb
    {db 66h, 0a5h}
    dec cx
    jnz @XLoop
    { neuen y-Screen-Offset bestimmen... }
    add di, xkonstante

    dec bx
    jns @YLoop
    pop ds
  end;
end;

begin;
  asm
    mov ax, 13h
    int 10h
  end;
  assign(f, 'fract049.bmp');
  reset(f, 1);
  getmem(p, 64000);
  seek(f, $36);
  blockread(f, p^, 1024);
  setpal;
  blockread(f, p^, $ffff);
  gettime(hour, minute, sec, sec100);
  zoom:=0;
  x:=0;
  y:=0;
  zf:=false;
  xf:=false;
  randomize;
  repeat;
    buildscreen(1, 1,  zoom, 0);
    if zf then dec(zoom, 2) else inc(zoom, 2);
    if (random(zw)=1) or (zoom <=-120) or (zoom >1527) then begin;
      if zf then zf:=false else zf :=true;
      zw:=20
    end;
    dec(zw);
    if xf then dec(x) else inc(x);
    if x <=-120 then xf:=false;
    if x >127 then xf:=true;
    if yf then dec(y) else inc(y);
    if y <=-120 then yf:=false;
    if y >127 then yf:=true;
    inc(d);
  until (keypressed);
  gettime(hour2, minute2, sec2, sec1002);
  asm;
    mov ax, 3
    int 10h
  end;
  time:=sec2-sec;
  writeln(' Testdauer : ', time,' Sekunden. ');
  freemem(p, 64000);
end.