{$a+,b-,d-,e-,f-,g+,I-,k-,l-,n-,o-,p-,q-,r-,s-,t-,v+,x-,y-}
 {a+,b-,d-,e-,f-,g+,I-,k-,l-,n-,o-,p-,q-,r-,s-,t-,v+,x-,y-}
{$c MOVEABLE PRELOAD Discardable}
 {c MOVEABLE PRELOAD Discardable}
{$m 1024, 0, 655360}
 {m 1024, 0, 655360}

unit grtools;

interface
  Procedure SetPal(col, r, g, b:byte);
  Procedure WaitRetrace;
  Procedure Setstart(Adr:Word);
  Procedure SetModeX;
  Procedure XPutPixel(x, y:word;col:byte);
  Procedure XEnter400;
  Procedure XDouble;
  Procedure CopyPage(ziel, quelle:word);
  Procedure PutPixel(x, y : word; col : byte);

implementation

Procedure SetCol(col, r, g, b:byte); Assembler;
asm
  mov dx, $3c8
  mov al, col
  out dx, al

  mov dx, $3c9
  mov al, r
  out dx, al

  mov al, g
  out dx, al

  mov al, b
  out dx, al
end;

Procedure PutPixel(x, y : word; col : byte);
begin;
  mem[$a000:y*320+x]:=col;
end;

Procedure SetPal(col, r, g, b:byte);
begin;
  SetCol(col, r div 4, g div 4, b div 4);
end;

Procedure WaitRetrace; assembler;
asm
  mov dx,$3da
  @x: in al, dx
      test al, 08h
      jnz @x
  @y: in al, dx
    test al, 08h
    jz @y
end;

Procedure SetModeX; assembler;
asm
  mov  ax, 13h
  int  10h                              { Modus 13h }
  mov  dx, 03c4h
  mov  al, 04h                          { TS-Register 4 anwhlen }
  out  dx, al
  inc  dx
  in   al, dx                           { aktuellen Register-Inhalt holen }
  and  al, 0f7h                         { Bit 2 setzen, Bit 3 lschen }
  or   al, 4
  out  dx, al                           { Werte zurckschreiben }
  dec  dx
  mov  ax, 0f02h
  out  dx, ax                           { alle Planes selektieren }
  mov  ax, 0a000h                      { VGA-Segment nach ES }
  mov  es, ax
  xor  di, di
  xor  ax, ax
  mov  cx, 0ffffh
  cld
  rep  stosw                            { Bildschirm lschen }
  mov  dx, 03d4h
  mov  al, 14h                          { CRTC-Register 14h anwhlen }
  out  dx, al
  inc  dx
  in   al, dx                           { Aktuellen Register-Inhalt holen }
  and  al, 0bfh                         { Bit 6 lschen }
  out  dx, al
  dec  dx
  mov  al, 17h                          { CRTC-Register 17h anwhlen }
  out  dx, al
  inc  dx
  in   al, dx
  or   al, 40h                          { Bit 6 setzen }
  out  dx, al
end;

Procedure split(row:byte); assembler;
asm;
  mov bl, row
  xor bh, bh
  shl bx, 1                             { *2 wg. Zeilenverdoppelung }
  mov cx, bx

  mov dx, 3d4h                          { CRTC }
  mov al, 07h                           { Register 7 (Overflow low) }
  out dx, al
  inc dx
  in al, dx
  and al, 11101111b                     { Bit 4 mit Bit 8 der Zeile laden }
  shr cx, 4
  and cl, 16
  or al, cl
  out dx, al                            { und setzen }

  dec dx
  mov al, 09h                           { Register 9 ( Maximum Row Adress ) }
  out dx, al
  inc dx
  in al, dx
  and al, 10111111b                     { Bit 6 mit Bit 9 der Zeile laden }
  shr bl, 3
  and bl, 64
  or al, bl
  out dx, al                            { und setzen }
  dec dx
  mov al, 18h                           { Register 18h (Line Compare/Split Screen ) }
  mov ah, row                           { restlichen 8 Bit setzen }
  shl ah, 1
  out dx, ax
ret
end;

Procedure XPutPixel(x, y:word;col:byte);assembler;
asm
  mov  ax, 0a000h
  mov  es, ax                           { VGA-Segment nach ES }
  mov  cx, x                            { X-Koordinate nach CX }
  and  cx, 3                            { Plane bestimmen }
  mov  ax, 1
  shl  ax, cl                           { entsprechendes Bit setzen }
  mov  ah, al
  mov  dx, 03c4h
  mov  al, 2                            { Timing-Sequencer Reg. 2 anwhlen }
  out  dx, ax                           { Plane setzen }
  mov  ax, 80                           { Pixel-Offset bestimmen }
  mul  y                                { Offset = y*80 + x div 4 }
  mov  di, ax                           { y*80 nach di }
  mov  ax, x
  shr  ax, 2                            { entspricht AX div 4 }
  add  di, ax                           { x div 4 dazuzhlen }
  mov  al, col                          { Farbe nach AL }
  mov  es:[di], al                      { Pixel setzen }
end;

Procedure SetStart(Adr:word);assembler;
asm
  mov  dx, 3d4h
  mov  al, 0ch                          { CRTC-Register 0ch }
  mov  ah, byte ptr adr +1              { Bits 15-8 abschicken }
  out  dx, ax
  mov  al, 0dh                          { CRTC-Register 0dh }
  mov  ah, byte ptr adr                 { Bits 7-0 abschicken }
  out  dx, ax
end;

Procedure CopyPage(ziel, quelle:word);assembler;
asm
  push ds
  mov  dx, 3c4h
  mov  ax, 0f02h
  out  dx, ax
  mov  dx, 3ceh
  mov  ax, 4105h
  out  dx, ax
  mov  ax, 0a000h
  mov  ds, ax
  mov  es, ax
  mov  si, quelle
  mov  di, ziel
  mov cx, 16000
  rep movsb
  mov  dx, 3ceh
  mov  ax, 4005h
  out  dx, ax
  pop ds
end;

Procedure XEnter400; assembler;
asm
  mov  dx, 3d4h
  mov  al, 9
  out  dx, al
  inc  dx
  in   al, dx
  and  al, 70h
  out  dx, al
end;

Procedure XDouble; assembler;
asm
  mov  dx, 3d4h
  mov  ax, 5013h
  out  dx, ax
end;

end.
