{$N+,E-}

uses crt;

const
  bmpfile = 'fract043.bmp';
  r       = 1024;
  d       = 4;

type
  bldarr = array[0..65000] of byte;

var
  bmp  : pointer;
  dac  : array[0..255,0..2] of byte;
  x,y  : integer;
  f    : file;
  buf  : array[0..255] of byte;
  ang  : ^bldarr;
  wid  : ^bldarr;
  a    : byte;
  ar   : single;
  w    : byte;
  pos  : word;
  xa   : byte;
  ya   : byte;
  bpos : word;

procedure initgraph; assembler;
asm
  mov  ax,13h
  int  10h
end;

procedure loadbitmap;
var
  y   : byte;
begin
  assign(f,bmpfile);
  reset(f,1);
  seek(f,$36);
  for y:=0 to 255 do
    begin
    blockread(f,buf,4);
    dac[y,0]:=buf[2] shr 2;
    dac[y,1]:=buf[1] shr 2;
    dac[y,2]:=buf[0] shr 2;
    end;
  for y:=0 to 255 do
    begin
    blockread(f,buf,256);
    asm
      mov  es,word ptr bmp+2
      mov  bx,0ff00h
      sub  bh,y
      mov  di,bx
      mov  si,offset buf
      mov  cx,128
      rep  movsw
    end;
    end;
  close(f);
  asm
    mov  ax,seg dac
    mov  es,ax
    mov  dx,offset dac
    mov  ah,10h
    mov  al,12h
    xor  bx,bx
    mov  cx,256
    int  10h
  end;
end;

begin
  initgraph;
  getmem(bmp,64000);
  getmem(ang,64000);
  getmem(wid,$FFFF);
  loadbitmap;
  pos:=0;
  for y:=-100 to 99 do
    for x:=-160 to 159 do
      begin
      if x>0 then ar:=arctan(y/x);
      if x<0 then ar:=pi-arctan(-y/x);
      if x=0 then
        begin
        if y>0 then ar:=pi/2;
        if y<0 then ar:=-pi/2;
        if y=0 then ar:=0;
        end;
      a:=round((ar*128/pi)+128);
      ang^[pos]:=a;
      if x<>0 then w:=abs(round(cos(ar)*r*d/x)) else
        begin
        w:=wid^[pos-1];
        end;
      wid^[pos]:=w;
      inc(pos);
      end;

  xa:=0;
  ya:=0;
  repeat
  asm
    push ds

    mov  al,xa
    mov  ah,ya
    mov  si,ax
    mov  dx,word ptr ang+2
    db   08Eh,0E2h        { mov fs,dx }
    mov  dx,word ptr wid+2
    db   08Eh,0EAh        { mov gs,dx }
    mov  dx,0A000h
    mov  es,dx
    mov  ds,word ptr bmp+2

    xor  di,di

  @schleife:
    mov  ax,si

    db   064h,066h,08Bh,015h    { mov edx,fs:[di] }
    add  dl,al
    add  dh,al
    db   066h,0C1h,0C2h,010h    { rol edx,16 }
    add  dl,al
    add  dh,al

    db   065h,066h,08Bh,00Dh    { mov ecx,gs:[di] }
    add  cl,ah
    add  ch,ah
    db   066h,0C1h,0C1h,010h    { rol ecx,16 }
    add  cl,ah
    add  ch,ah

    mov  bl,dl
    mov  bh,cl
    mov  al,[bx]

    mov  bl,dh
    mov  bh,ch
    mov  ah,[bx]

    db   066h,0C1h,0E0h,010h    { shl eax,16 }
    db   066h,0C1h,0EAh,010h    { shr edx,16 }
    db   066h,0C1h,0E9h,010h    { shr ecx,16 }

    mov  bl,dl
    mov  bh,cl
    mov  al,[bx]

    mov  bl,dh
    mov  bh,ch
    mov  ah,[bx]

    db   066h,0ABh              { stosd }

    cmp  di,64000
    jb   @schleife

    pop  ds

    dec  xa
    inc ya
    end;
  until keypressed;
  freemem(wid,64000);
  freemem(ang,64000);
  freemem(bmp,$FFFF);
  textmode(co80);
end.
