{Programm zum Erstellen einfacher Balkendiagramme bei Fabian Wleklinski
Die Benutzung durch jedermann ist erlaubt, nicht so die Modifikation}
uses graph,crt;
{Variablendefinition}
var
grDriver: integer;
grmode: integer;
eingabe: char;
wert: array [1..12] of real;
hoehe: array [1..12] of longint;
angabe: array [1..12] of string;
prozentangabe: array[1..12] of string;
nummer: array[1..12] of string;
maxwert: real;
maxwert2: real;
maxwert3: real;
zahler: byte;
skala: array [1..4] of string;
ablage: integer;
winkel: array [1..12] of word;

Procedure GrafikTreiber; external;
{$l egavga}

{Prozedur um Kreisdiagramm darzustellen}
procedure Kreisdiagramm;
begin;
{Maximaler Winkel wird aufgeteilt}
maxwert2:=0;
zahler:=1;
          repeat;
                 maxwert2:=(maxwert2+wert[zahler]);
          zahler:=(zahler+1);
          until zahler=13;
          maxwert3:=(360/maxwert2);
{Winkel werden festgelegt}
zahler:=1;
         repeat;
                winkel[zahler]:=round(wert[zahler]*maxwert3);
                zahler:=(zahler+1);
         until zahler=13;
{Prozentangabe fr Kreisanteile werden berechnet}
zahler:=1;
         repeat;
         str(round(wert[zahler]*100/maxwert2),prozentangabe[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Absolutwertangabe fr Kreisanteile werden berechnet}
zahler:=1;
         repeat;
         str(round(wert[zahler]),angabe[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Nummern werden in Strings konvertiert}
zahler:=1;
         repeat;
         str(zahler,nummer[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Grafiktreiber wird aktiviert}
grdriver:=0;
initgraph(grdriver, grmode,'');
{Schriftzug ber Grafik wird aufgebaut}
settextstyle(defaultfont,horizdir,1);
outtextxy(195,0,'Kreisdiagramm, Supreme-Soft 1995');
settextstyle(defaultfont,horizdir,1);
{Kreisdiagramm darstellen};
ablage:=0;
zahler:=1;
setcolor(0);
repeat;
setfillstyle(solidfill,zahler);
pieslice(370,240,ablage,ablage+(winkel[zahler]),200);
ablage:=(ablage+winkel[zahler]);
zahler:=(zahler+1);
until ((zahler=12) or (winkel[zahler+1]=0));
setfillstyle(solidfill,zahler);
pieslice(370,240,ablage,360,200);{Manuell die Rechenungenauigkeit ausgleichen}
{Legende fr Kreisdiagramm abbilden}
zahler:=1;
repeat;
setcolor(zahler);
setfillstyle(solidfill,zahler);
rectangle(50,30+zahler*30,100,45+zahler*30);
outtextxy(1,30+zahler*30,'Wert');
outtextxy(1,40+zahler*30,'Nr.'+nummer[zahler]);
zahler:=(zahler+1);
until ((zahler=13) or (wert[zahler]=0));
{Absolutwerte an Skala fr Kreisanteile anfgen}
zahler:=1;
repeat;
setcolor(15);{Weie Farbe fr die absoluten Werte}
outtextxy(110,30+zahler*30,angabe[zahler]);
zahler:=(zahler+1);
until ((zahler=13) or (wert[zahler]=0));
{Prozentwerte an Skale fr Kreisanteile anhngen}
zahler:=1;
repeat;
outtextxy(110,40+zahler*30,prozentangabe[zahler]+' %');
zahler:=(zahler+1);
until ((zahler=13) or (wert[zahler]=0));
{Warten auf Tastendruck, um zu verlassen}
repeat;
until keypressed;
restorecrtmode;
end;
{Prozedur um waagerechte Balken darzustellen}
procedure HorizontalBalken;
begin;
{Lnge der Balken wird berechnet}
zahler:=1;
          repeat
          hoehe[zahler]:=round(500*(wert[zahler]/maxwert));
          zahler:=(zahler+1);
          until zahler=13;
{Prozentangabe fr Sulen oben und unten wird berechnet}
zahler:=1;
         repeat;
         str(round(wert[zahler]*100/maxwert),prozentangabe[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Absolutwertangabe fr Sulen oben und unten wird berechnet}
zahler:=1;
         repeat;
         str(round(wert[zahler]),angabe[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Grafiktreiber wird aktiviert}
grdriver:=0;
initgraph(grdriver, grmode,'');
{Schriftzug ber Grafik wird aufgebaut}
settextstyle(defaultfont,horizdir,1);
outtextxy(195,0,'Balkendiagramm, Supreme-Soft 1995');
settextstyle(defaultfont,horizdir,1);
{Aufbauen des Hintergrundes fr 3D-Horizontal-Balken}
setfillstyle(solidfill,3);{Farben fr Linien im Hintergrund setzen}
setcolor(3);
{horizontale Linien im Hintergrund der Balken}
line(76,17,575,17);
line(76,52,575,52);
line(76,87,575,87);
line(76,122,575,122);
line(76,157,575,157);
line(76,192,575,192);
line(76,227,575,227);
line(76,262,575,262);
line(76,297,575,297);
line(76,332,575,332);
line(76,367,575,367);
line(76,402,575,402);
line(76,437,575,437);
bar3d(50,35,50,455,25,topon);{Quader oben links}
bar3d(0,35,50,35,25,topon);{linksstehende "Wand" zeichnen}
rectangle(0,35,50,455);{Vorderansicht von linksstehender "Wand"}
line(575,17,575,437);{rechtsseitige Begrenzungslinie zeichnen}
{Aufbauen der Skala mit Absolutwerten unterhalb der Statistikwand}
setcolor(3);
setfillstyle(solidfill,3);
bar3d(50,455,175,455,25,topoff);{Ablageflche malen}
bar3d(175,455,300,455,25,topoff);{Ablageflche malen}
bar3d(300,455,425,455,25,topoff);{Ablageflche malen}
bar3d(425,455,550,455,25,topoff);{Ablageflche malen}
setcolor(15);
line(50,456,50,465);
line(175,456,175,465);
line(300,456,300,465);
line(425,456,425,465);
line(550,456,550,465);
outtextxy(50,470,'0');
outtextxy(175,470,skala[4]);
outtextxy(300,470,skala[3]);
outtextxy(425,470,skala[2]);
outtextxy(550,470,skala[1]);
{Aufbauen der 3Dimensionalen-Horizontalen Balken}
setfillstyle(solidfill,9);
setcolor(9);
zahler:=0;
repeat;
if wert[12-zahler]<>0 then
   begin;
   bar3d(55,427-zahler*35,55+hoehe[12-zahler],444-zahler*35,20,topon);
   end;
zahler:=(zahler+1);
until (zahler=12) ;
{Beschriftung der 3D-Horiziontal-Balken}
setcolor(15);{Weie Farbe fr Prozentangaben}
zahler:=1;
repeat
      outtextxy(3,10+(zahler*35),angabe[zahler]);
      zahler:=(zahler+1);
until ((zahler=13) or (wert[zahler]=0));
zahler:=1;
repeat
      outtextxy(3,20+(zahler*35),prozentangabe[zahler]+'%');
      zahler:=(zahler+1);
until ((zahler=13) or (wert[zahler]=0));
{Schreiben der Nummern in Strings}
zahler:=1;
repeat;
str(zahler,nummer[zahler]);
zahler:=(zahler+1);
until zahler=13;
{Schreiben der Wertnummern rechts von der Darstellung}
zahler:=0;
repeat;
outtextxy(585,22+35*zahler,'Wert');
outtextxy(585,32+35*zahler,'Nr.'+nummer[zahler+1]);
zahler:=(zahler+1);
until ((zahler=12) or (wert[zahler+1]=0));
repeat;
until keypressed;
restorecrtmode;
end;
{Prozedur, um Senkrechtbalken darzustellen}
procedure SenkrechtBalken;
{Hhen der Sulen werden berechnet}
     begin;
     zahler:=1;
     repeat;
            if wert[zahler]<>0 then
               begin;
               hoehe[zahler]:=round(200-150*(wert[zahler]/maxwert));
            end
            else
            begin
                hoehe[zahler]:=200;
                end;
            zahler:=(zahler+1);
     until zahler=13;
{Prozentangabe fr Sulen oben und unten wird berechnet}
zahler:=1;
         repeat;
         str(round(wert[zahler]*100/maxwert),prozentangabe[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Absolutwertangabe fr Sulen oben und unten wird berechnet}
zahler:=1;
         repeat;
         str(round(wert[zahler]),angabe[zahler]);
         zahler:=(zahler+1);
         until zahler=13;
{Grafiktreiber wird aktiviert}
grdriver:=0;
grmode:=0;
initgraph(grdriver, grmode,'');
{Schriftzug ber Grafik wird aufgebaut}
settextstyle(defaultfont,horizdir,1);
outtextxy(195,0,'Balkendiagramm, Supreme-Soft 1995');
settextstyle(defaultfont,horizdir,1);
{Hintergrund der oberen Ebene wird aufgebaut}
setcolor(3);
setfillstyle(solidfill,3);
bar3d (10,50,10,88,25,topon);
bar3d (10,88,10,125,25,topoff);
bar3d (10,125,10,163,25,topoff);
bar3d (10,163,10,200,25,topoff);
rectangle (35,32,639,70);
rectangle (35,70,639,107);
rectangle (35,107,639,145);
rectangle (35,145,639,182);
line (10,200,614,200);
line (614,200,639,182);
{Die Sulen der ersten Ebene werden beschriftet}
outtextxy(15,50,skala[1]);
outtextxy(15,88,skala[2]);
outtextxy(15,125,skala[3]);
outtextxy(15,163,skala[4]);
outtextxy(15,200,'0');
{Die Sulen in der ersten horizontalen Reihe werden aufgebaut}
setcolor(9);
setfillstyle(solidfill,9);
zahler:=0;
repeat;
bar3d (50+zahler*100,hoehe[zahler+1],100+zahler*100,200,25,topon);
zahler:=(zahler+1);
until ((zahler=6) or (wert[zahler+1]=0));
{Die Nummern werden in Strings konvertiert}
zahler:=1;
repeat;
str(zahler,nummer[zahler]);
zahler:=(zahler+1);
until zahler=13;
{Beschriftung der senkrechten Sulen der oberen Ebene}
setcolor(15);{Weie Farbe fr Prozentangaben}
zahler:=0;
repeat
outtextxy(50+zahler*100,205,'Wert Nr.'+nummer[zahler+1]);
outtextxy(50+zahler*100,215,angabe[zahler+1]);
outtextxy(50+zahler*100,225,prozentangabe[zahler+1]+'%');
zahler:=(zahler+1);
until ((zahler=6) or (wert[zahler+1]=0));
{Der Hintergrund der unteren Ebene wird aufgebaut}
setcolor(3);
setfillstyle(solidfill,3);
bar3d (10,270,10,308,25,topon);
bar3d (10,308,10,345,25,topoff);
bar3d (10,345,10,383,25,topoff);
bar3d (10,383,10,420,25,topoff);
rectangle (35,252,639,290);
rectangle (35,290,639,327);
rectangle (35,327,639,365);
rectangle (35,365,639,402);
line (10,420,614,420);
line (614,420,639,402);
outtextxy(15,270,skala[1]);
outtextxy(15,308,skala[2]);
outtextxy(15,345,skala[3]);
outtextxy(15,383,skala[4]);
outtextxy(15,420,'0');
{Die Sulen in der unteren horizontalen Reihe werden aufgebaut}
setcolor(9);
setfillstyle(solidfill,9);
zahler:=6;
repeat;
bar3d (50+(zahler-6)*100,220+hoehe[zahler+1],100+(zahler-6)*100,420,25,topon);
zahler:=(zahler+1);
until ((zahler=12) or (wert[zahler+1]=0));
{Beschriftung der senkrechten Sulen der unteren Ebene}
setcolor(15);{Weie Farbe fr Prozentangaben}
zahler:=6;
repeat;
outtextxy(50+(zahler-6)*100,425,'Wert Nr.'+nummer[zahler+1]);
outtextxy(50+(zahler-6)*100,435,angabe[zahler+1]);
outtextxy(50+(zahler-6)*100,445,prozentangabe[zahler+1]+'%');
zahler:=(zahler+1);
until ((zahler=12) or (wert[zahler+1]=0));
repeat;
until keypressed;
restorecrtmode;
end;
procedure skal; {Skala fr beide Ebenen wird erzeugt}
begin;
      str(round(maxwert),skala[1]);
      str(round(maxwert*0.75),skala[2]);
      str(round(maxwert*0.5),skala[3]);
      str(round(maxwert*0.25),skala[4]);
end;
{Eingabe der Werte im Textmodus}
begin
     if registerbgidriver(@grafiktreiber)<0 then
begin
write('Datei-Fehler !');
halt;
end;

     clrscr;
     writeln('Balkendiagramm V 1.0, Supreme-Soft 1995');
     writeln;
     writeln('Geben sie bitte bis zu zwlf positive Werte ein. Das Programm wird diese');
     writeln('grafisch darzustellen. Drcken sie bitte "0" nach dem letzten Wert.');
          zahler:=1;
          gotoxy(1,6);
               repeat;
                               writeln('Wert Nummer ',zahler,' :');
                               gotoxy(17,zahler+5);
                               readln(wert[zahler]);
                               if wert[zahler]=0 then zahler:=12;
                               zahler:=(zahler+1);
               until zahler=13;
{Maximalwert wird ermittelt}
     maxwert:=wert[1];
     zahler:=1;
     repeat;
            if (wert[zahler]>maxwert) then maxwert:= wert[zahler];
               zahler:=(zahler+1);
     until zahler=13;
skal;
repeat;
clrscr;
writeln('1) fr Horizontale Balken,');
writeln('2) fr Senkrechte Balken und');
writeln('3) fr ein Kreisdiagramm.');
writeln;
writeln('0) fr Verlassen von Statistik 1.0');
gotoxy(1,7);
writeln('Ihre Wahl:');
gotoxy(12,7);
read(eingabe);
if eingabe=('1') then horizontalbalken;
if eingabe=('2') then senkrechtbalken;
if eingabe=('3') then kreisdiagramm;
writeln('Supreme-Soft dankt fr die Benutzung von Statistik V 1.0 !!')
until eingabe=('0');
end.