{
  Dieses Programm sichert den Bios-Datenbereich in einer Datei mit fortlaufendem
  Suffix auf einer Diskette in Laufwerk A:. Es wurde geschrieben, da ich eine
  mglichst groe Anzahl von Bios-Kennungen gesucht habe.
}

{$i+,d+}

uses crt, dos;

const
  header1     : string = #13+#10+#13+#10+#13+#10+#13+#10+' short description                       ';
  header2     : string = #13+#10+#13+#10+#13+#10+#13+#10+' AUTOEXEC.BAT'+#13+#10+#13+#10;
  header3     : string = #13+#10+#13+#10+#13+#10+#13+#10+' CONFIG.SYS'+#13+#10+#13+#10;

type
  bytefield   = array [0..$fffe] of byte;

var
  f: file;
  mySearchrec : searchrec;
  i           : byte;
  filename    : string;
  ablage      : string;
  ablage2     : string;
  a           : word;
  p1          : ^byteField;
  syslength1  : word;
  sysLength2 : word;


begin
  checkBreak:=false;
  textcolor(7);
  writeln;
  writeln;
  writeln(' biosDump revision 1.0');
  writeln('  iCode prod. 1996 - code by falcon');
  writeln;
  writeln('  press ESC to abort - other keys to continue');
  if readkey=#27 then
  begin;
    writeln;
    writeln('  user terminated');
    writeln;
    halt;
  end;
  i:=0;
  repeat;
    str(i, ablage);
    if i<100 then ablage:='0'+ablage;
    if i<10 then ablage:='0'+ablage;
    filename :='a:\BIOSDUMP.'+ablage;
    findfirst(filename,$3f,mySearchrec);
    a:=dosError;
    if a=0 then inc(i);
  until a<>0;

  writeln;
  write('  short description   ');
  textcolor(14);
  read(ablage);
  textcolor(7);
  writeln;
  for i:=0 to byte(ablage[0]) do ablage2[i]:=ablage[i+1];


  { system-dateien sichern }
  getmem(p1, $ffff);
  assign(f, 'C:\AUTOEXEC.BAT');
  reset(f, 1);
  i:=0;
  repeat;
    a:=filesize(f)-filepos(f);
    if a>256 then a:=256;
    blockread(f, p1^[i*256], a);
    inc(i);
    inc(syslength1, a);
  until a<>256;
  close(f);
  assign(f, 'C:\CONFIG.SYS');
  reset(f, 1);
  repeat;
    a:=filesize(f)-filepos(f);
    if a>256 then a:=256;
    blockread(f, p1^[i*256], a);
    inc(i);
    inc(syslength2, a);
  until a<>256;
  close(f);

  write('  dumping bios-data to file ');
  assign(f, filename);
  rewrite(f, 1);
  for i:=0 to 15 do begin
    write('.');
    blockwrite(f, mem[$f000:i*$1000], $1000);
    a:=ioresult;
    if ioresult<>0 then
    begin
      writeln;
      writeln;
      writeln('  error writing data');
      writeln('  execution stoped');
      writeln;
      close(f);
      halt(a);
    end;
  end;


  { Jetzt den Kommentar sichern }

  blockwrite(f, ptr(seg(header1),1+ofs(header1))^, byte(header1[0]));
  blockwrite(f, ablage2, byte(ablage[0]));
  writeln;

  blockwrite(f, ptr(seg(header2),1+ofs(header2))^, byte(header2[0]));
  write('  dumping system data to file ');
  i:=0;
  repeat;
    write('.');
    a:=sysLength1;
    if a>256 then a:=256;
    blockwrite(f, p1^[i*256], a);
    inc(i);
    dec(sysLength1, 256);
  until (a<>256) or (sysLength1<0);

  blockwrite(f, ptr(seg(header3),1+ofs(header3))^, byte(header3[0]));
  repeat;
    write('.');
    a:=sysLength2;
    if a>256 then a:=256;
    blockwrite(f, p1^[i*256], a);
    inc(i);
    dec(sysLength2, 256);
  until (a<>256) or (sysLength2<0);
  close(f);

  writeln;
  writeln;
  writeln('  everything done');
  writeln;
  freemem(p1, $ffff);
end.