uses crt,dos;

type
  a            =     array[0..$fffe]of byte;

const
  xstart        :       byte = 50;

var
  s            :     ^a;
  cosinus        :     array [0..359] of real;
  sinus          :     array [0..359] of real;
  puffer       :       string;
  r, g, b      :       Byte;
  filename     :     string;
  Colour       :     array [0..255,0..2] of byte;
  bmpfile      :     file;
  x            :     word;
  y            :     word;
  i            :     word;
  i2           :     word;
  i3           :     word;
  Data         :     record
                       Start    :       Integer;
                     end;

Procedure create_sinusarray;
begin;
  writeln('Creatings Coinus-array...');
  for i:= 0 to 359 do cosinus [i]:= cos(i*3.1416/180);
  for i:= 0 to 359 do sinus [i]:= sin(i*3.1416/180);
end;

Procedure WaitRetrace; assembler;
asm
  mov dx,$3da
  @x: in al, dx
      test al, 08h
      jnz @x
  @y: in al, dx
    test al, 08h
    jz @y
end;

Procedure SetPal(col, r, g, b:Byte);
begin;
  port[$3c8]:=col;
  port[$3c9]:=r div 4;
  port[$3c9]:=g div 4;
  port[$3c9]:=b div 4;
end;

Procedure MoveData;
var
  s2 : ^a;
  i3 : word;
begin;
  getmem(s2,64000);
  i:=0;
  i2:=64000-320;
  repeat;
    for i3:=0 to 319 do s2^[i2+i3]:=s^[i+i3];
    inc(i, 320);
    dec(i2,320);
  until i2=0;
  for i:=0 to 63999 do s^[i]:=s2^[i];
  freemem(s2,64000);

end;

{Procedure BuildScreen;
var d:word;
begin;
  Close(bmpfile);
  d:=seg(s^);
  asm
    mov ax, d

    mov ds, ax
    xor si, si                          { DS:SI -> ADDR S}

    {mov ax, $a000
    mov es, ax
    mov di, $0                       { ES:DI -> ADDR VGA}

    {cld
    mov cx, 32000
    rep movsw
  end;
end;}

Procedure BuildScreen;
var
  alpha : longint;
  x : real;
  oldx : real;
  y:word;
  a:byte;
  i3 : word;
  yv1, yv2 : word;
begin;
  x:=160+cosinus[0]*100;
  for alpha:=0 to 359 do begin;
    x:=160+cosinus[alpha]*120;
    {if abs(oldx)+1<abs(x) then begin;
      if alpha<180 then x:=x+1 else x:=x-1;
      if alpha > 180 then dec(alpha) else inc(alpha);
    end;}
    if alpha<180 then begin;
      yv1:=100-40-round((sinus[alpha])*20);
      yv2:=100+40+round((sinus[alpha])*20);
    end else begin;
      yv1:=120-40+round((sinus[alpha-180])*20);
      yv2:=120+40+round((sinus[alpha-180])*20);
    end;
    y:=yv1;
    repeat;
      {mem[$a000:round(y*320+x)]:=s^[round((200 div (yv2-yv1))*y*320+alpha)];}
      mem[$a000:round(y*320+x)]:=s^[round((100 div (yv2-yv1))*y*320+alpha)];
      inc(y);
    until y>yv2;
    oldx:=x;
  end;
end;


begin;
  create_sinusarray;
  filename:='fract043.bmp';
  getmem(s,$ffff);
  assign(bmpfile,filename);
  reset(bmpfile,1);
  blockread(bmpfile,s^,$d);
  Data.Start:=s^[$a]+longint(s^[$b])*256+longint(s^[$c])*65536;
  asm
    mov ax, $13
    int 10h
  end;
  seek(Bmpfile,$36);
  blockread(Bmpfile,s^,1024);
  for i:=0 to 255 do begin;
      setpal(i,s^[i*4+2],s^[i*4+1],s^[i*4]);
  end;
  seek(bmpfile, data.start);
  blockread(bmpfile,s^,filesize(bmpfile)-filepos(bmpfile));
  movedata;
  BuildScreen;
  asm
    xor ax, ax
    int 16h
    mov ax,0003h
    int 10h
  end;
end.
