uses crt;

var b     : byte;
    state : byte;
    b13   : boolean;
    s1    : byte;
    s2    : byte;

procedure init;
begin
  asm
    mov dx, 1
    mov ah, 0
    mov al, 11100111b
    int 14h
  end;
end;

procedure _out( b : byte);
begin
  asm
    mov ah, 1
    mov al, b
    mov dx, 1
    int 14h
    mov state, al
  end;
end;

function _in: byte;
begin
  asm
    mov b, 0
    mov dx, 1
    mov ah, 2
    int 14h
    test ah, 128
    jnz @state
    mov b, al
  @state:
    mov state, ah
  end;
  _in:=b;
end;

procedure checkState;
begin
  asm
    mov dx, 1
    mov ah, 3
    int 14h
    mov state, ah
  end;
end;

begin
  writeln;
  writeln;
  writeln(' Ŀ');
  writeln('                                                                            ');
  writeln('                     iCode SEPODA 1.oo                          ');
  writeln('                                                                            ');
  writeln('                        serial port data output                             ');
  writeln('                                                                            ');
  writeln('   usage: SEPODA COMPORT instructions              example: SEPODA 1 ATH    ');
  writeln(' ');
  writeln;
  init;

  textColor(14);

  repeat;
    repeat;
      checkState;
      { stehen Daten bereit? }
      while state and 1 = 1 do
      begin
        b := _in;
        if (b<>10) and (b<>13) then b13 := false;
        if (b=10) and (not b13) then write(#13);
        write( char( b ) );
        if (b<>10) and (b13) then write(#10);
        if b=13 then b13:=true;
      end;
    until keypressed;
    b := byte(readkey);
    _out( b );
  until b=27;

  textcolor(7);
end.
