uses crt;

var b     : byte;
    state : byte;
    s1    : byte;
    s2    : byte;
    done  : boolean;
    comport : word;

procedure error( el : byte );
begin
  writeln;
  writeln(' Fehler !!');
  writeln;
  if el=1 then writeln('Kommandozeilenparameter 1 mu ein Wert von 1 bis 4 sein !!');
  if el=2 then writeln('Kommandozeilenparameter 2 - ?? mssen Modem-Instruktionen sein !!');
  writeln;
  halt(1);
end;

procedure init;
var e : integer;
begin
  val( paramstr(1) , comport , e );
  if e<> 0 then error(1);
  dec( comport );
  asm
    mov dx, comport
    mov ah, 0
    mov al, 11100111b
    int 14h
  end;
end;

procedure _out( b : byte);
begin
  asm
    mov ah, 1
    mov al, b
    mov dx, comport
    int 14h
    mov state, al
  end;
end;

function getnextbyte: byte;
var ablage : string;
begin
  getnextbyte := 0;
  ablage := paramstr(s1);
  if ablage = '' then begin
    done := true;
    _out( 13 ); _out( 10 );
    exit;
  end;
  getnextbyte := byte( ablage[s2] );
  inc(s2);
  if s2> byte(ablage[0]) then
  begin
    s2 := 1;
    inc( s1 );
    ablage := paramstr(s1);
    _out( 32 );
  end;
end;


function _in: byte;
begin
  asm
    mov b, 0
    mov dx, comport
    mov ah, 2
    int 14h
    test ah, 128
    jnz @state
    mov b, al
  @state:
    mov state, ah
  end;
  _in:=b;
end;

procedure checkState;
begin
  asm
    mov dx, comport
    mov ah, 3
    int 14h
    mov state, ah
  end;
end;

begin
  done := false; s1 := 2; s2:=1;
  textColor( 7 );
  writeln;
  writeln;
  writeln(' Ŀ');
  writeln('                                                                            ');
  writeln('                     iCode SEPODA 1.oo                          ');
  writeln('                                                                            ');
  writeln('                        serial port data output                             ');
  writeln('                                                                            ');
  writeln('   usage: SEPODA COMPORT instructions              example: SEPODA 1 ATH    ');
  writeln(' ');
  writeln;
  init;

  if paramcount < 2 then error(2);

  textColor(14);

  repeat;
    checkState;
    { stehen Daten bereit? }
    while state and 1 = 1 do b := _in;
    b := getnextbyte;
    if not done then _out( b );
  until done;

  textcolor(7);
end.
