{ Programm: shl.pas
  Funktion: Dateimanagment
  Sprache:  Turbo Pascal 7.0
  Autor:    max boone
  Datum:    Mai 1995 }

{$M 4096,0,0}

{ Da das Programm mglichst wenig Speicher belegen soll, knnte mann noch
  eine DOS-Speicherreservierung einbauen -> spter! }

uses dos,crt;

var  ScreenBuf : array[0..3999] of byte;
     CurPos    : word;

     fileBuf   : array[1..512] of string[13];

     actScr    : byte;
     actEntr   : word;
     maxEntr   : word;

     commandBuf : string; { Kommandozeile }
     homeDir    : string;

PROCEDURE GetScreen; assembler;
asm
        push ds
        push es

        mov  di,offset ScreenBuf
        mov  ax,ds
        mov  es,ax
        mov  ax,0b800h
        mov  ds,ax
        xor  si,si
        
        mov  cx,2000
        cld
        rep  movsw

        pop  es
        pop  ds
END;

PROCEDURE PutScreen; assembler;
asm
        push ds
        push es

        mov  si,offset ScreenBuf
        mov  ax,0b800h
        mov  es,ax
        xor  di,di
        
        mov  cx,2000
        cld
        rep  movsw

        pop  es
        pop  ds
END;

PROCEDURE GetCurXY; assembler;
asm
   mov	bh,0
   mov	ah,3h
   int	10h
    { ch,cl = CursorForm
     dh,dl = CursorPosition l=spalte}
   mov  CurPos,dx
end;

PROCEDURE SetCur; assembler;
asm
        mov     dx,CurPos
        mov     ah,2
        mov     bh,0
        int     10h
END;

PROCEDURE DrawList (real : word; scr : byte; mode : boolean);
VAR  st,ts,t3 : string;
     x        : byte;
     pm       : boolean;
BEGIN
     IF real>maxEntr THEN exit;

     IF mode THEN
      BEGIN TextColor(1); TextBackground(7); END
     ELSE
      BEGIN TextColor(14); TextBackground(1);END;

     st:=copy (fileBuf[real],1,12); pm:=false;
     fillchar (ts[1],12,32);

    IF st='..' THEN ts:='..          '
    ELSE
     FOR x:=1 TO 12 DO
      BEGIN
           IF st[x]='.' THEN
            BEGIN
                 pm:=TRUE;
                 ts[9]:=' ';
                 INC (x);
                 IF (byte(st[0])>=x) THEN ts[10]:=st[x];
                 INC (x);
                 IF (byte(st[0])>=x) THEN ts[11]:=st[x];
                 INC (x);
                 IF (byte(st[0])>=x) THEN ts[12]:=st[x];
                 x:=12;
            END;
           IF (x<=byte(st[0])) AND (NOT pm) THEN ts[x]:=st[x];
      END;
     gotoxy(50,10);Writeln(ts);
     ts[0]:=#12; st[13]:=fileBuf[real][13];

     t3:='--'; { Attributsache }
     IF (byte(st[13]) AND 1)=1 THEN t3[1]:='r';
     IF (byte(st[13]) AND 2)=2 THEN t3[2]:='h';

     gotoxy (4,scr+1);
     write (' ',ts,' ',t3,' ');
END;

PROCEDURE GetValues;
VAR  sr : SearchRec;
BEGIN
     actScr:=1; actEntr:=1; MaxEntr:=1;

     getDir (0,homeDir);

     FindFirst ('*.*',$10,sr); if (sr.name='.') and (DosError=0) then findnext (sr);
     if (sr.attr=16) and (DosError=0) then
      begin fileBuf[1]:=sr.name; fileBuf[1][13]:=char(sr.attr); maxEntr:=1; end
      else maxEntr:=0;

      repeat
            findnext (sr);
            if (sr.attr=16) and (DosError=0) then
             begin
                  inc (maxEntr);
                  fileBuf[maxEntr]:=sr.name;
                  fileBuf[maxEntr][13]:=char(sr.attr);
             end;
      until (DosError<>0) or (maxEntr=512);

      { So, und jetzt erst die Dateien }
      if maxEntr<512 then
       begin
             findfirst ('*.*',$3f,sr); if (sr.name='.') and (DosError=0) then findnext (sr);
             if (DosError=0) and (sr.attr<>$10) then
              begin inc (maxEntr); fileBuf[maxEntr]:=sr.name; fileBuf[maxEntr][13]:=char(sr.attr); end;

             repeat
                   findnext (sr);
                   if (DosError=0) and (sr.attr<>$10) then
                    begin
                         inc (maxEntr);
                         fileBuf[maxEntr]:=sr.name;
                         fileBuf[maxEntr][13]:=char(sr.attr);
                    end;
             until (DosError<>0) or (maxEntr=512);
       end;
END;

PROCEDURE DrawCommandLine;
VAR  st,ts : string;
BEGIN
     TextColor (7); TextBackground (0);
     gotoxy (1,24);

     st:='['+homeDir+']$'+commandBuf; ts:='';
     IF length(st)<80 THEN BEGIN fillchar (ts[1],80-length(st)+1,32);
                          ts[0]:=char(80-length(st)+1); END;
     write (copy(st,1,80),ts);
END;

PROCEDURE BuildScreen;
VAR  x : byte;
BEGIN
     { 1. Fenster zeichnen }
     asm
        mov ah,2 { gotoXY }
        mov dx,0002
        mov bh,0
        int 10h

        mov bl,1fh
        mov ah,9   { 191 192 217 218 }
        mov cx,1
        mov al,218
        int 10h

        mov ah,2 { gotoXY }
        inc dl
        int 10h

        mov ah,9
        mov cx,17
        mov al,196
        int 10h

        add dl,17
        mov ah,2 { gotoXY }
        int 10h

        mov ah,9
        mov cx,1
        mov al,191
        int 10h

      @lp1:
        inc dh
        mov dl,2
        mov ah,2
        int 10h

        mov ah,9
        mov al,179
        int 10h

        mov ah,2
        inc dl
        int 10h

        mov cx,17
        mov ax,0920h {9,32}
        mov bl,1eh
        int 10h

        mov ah,2
        add dl,17
        int 10h

        mov ah,9
        mov al,179
        mov bl,1fh
        mov cx,1
        int 10h

        cmp dh,21
        jb  @lp1

        mov ah,2 { gotoXY und die letzte Zeile  }
        mov dx,1602h
        mov bh,0
        int 10h

        mov bl,1fh
        mov ah,9   { 191 192 217 218 }
        mov cx,1
        mov al,192
        int 10h

        mov ah,2 { gotoXY }
        inc dl
        int 10h

        mov ah,9
        mov cx,17
        mov al,196
        int 10h

        add dl,17
        mov ah,2 { gotoXY }
        int 10h

        mov ah,9
        mov cx,1
        mov al,217
        int 10h
     end;

     FOR x:=1 TO 21 DO
      IF x=actScr THEN DrawList (actEntr,x,true)
      ELSE DrawList (actEntr-actScr+x,x,false);
     DrawCommandLine;
END;

PROCEDURE Execute (fname,param : string);
VAR  p,p2 : pathStr;
BEGIN
     PutScreen;
     SetCur;
     getDir (0,p);

     swapvectors;
     exec (fname,'');
     swapvectors;

     GetCurXY;
     GetScreen;
     getDir (0,p2);
     IF p<>p2 THEN GetValues;

     BuildScreen;
END;

PROCEDURE Run;
VAR  ch    : char;
     done  : boolean;
     x     : byte;
     st,t2 : string;
BEGIN
     done:=false;
     REPEAT
           IF KeyPressed THEN
            BEGIN
                 gotoxy(23,10);
                 ch:=readkey;

                 IF ch=#27 THEN done:=true;
                 IF ch=#13 THEN
                  BEGIN
                       IF commandBuf='' THEN
                        BEGIN
                             IF length(fileBuf[actEntr])>4 THEN
                              BEGIN
                                   st:=copy (fileBuf[actEntr],byte(fileBuf[actEntr][0])-2,3);
                                   IF (st='EXE') OR (st='COM') THEN Execute (fileBuf[actEntr],'');
                                   IF (st='BAT') THEN
                                    BEGIN
                                         Execute ('c:\command.com','/C'+fileBuf[actEntr]);
                                    END;
                              END;
                             IF (byte((fileBuf[actEntr][13])) AND 16)=16 THEN
                              BEGIN
                                   chdir (fileBuf[actEntr]);
                                   GetValues;
                                   BuildScreen;
                              END;
                        END
                       ELSE
                        BEGIN
                             Execute (commandBuf,'');
                             commandBuf:='';
                        END;
                  END;
                 IF (ch>#31) THEN
                  BEGIN
                       commandBuf:=commandBuf+ch;
                       DrawCommandLine;
                  END;

                 IF ch=#0 THEN
                  BEGIN
                       ch:=readkey;

                       CASE ch OF
                       'P': { Pfeil unten }
                         BEGIN
                              DrawList (actEntr,actScr,false);

                              IF actEntr<maxEntr THEN
                               BEGIN
                                    INC (actEntr);
                                    IF actScr<21 THEN INC (actScr)
                                    ELSE { Scrollen... }
                                     BEGIN
                                          FOR x:=1 TO 20 DO
                                           DrawList (actEntr-21+x,x,false);
                                     END;
                               END;

                              DrawList (actEntr,actScr,true);
                         END;
                        'H': { Pfeil oben }
                         BEGIN
                              DrawList (actEntr,actScr,false);

                              IF actEntr>1 THEN
                               BEGIN
                                    DEC (actEntr);
                                    IF actScr>1 THEN DEC (actScr)
                                    ELSE { Scrollen...}
                                     BEGIN
                                          FOR x:=2 TO 21 DO
                                           DrawList (actEntr+x-1,x,false);
                                     END;
                               END;

                              DrawList (actEntr,actScr,true);
                         END;
                        'O': { Ende }
                         BEGIN
                              DrawList (actEntr,actScr,false);
                              actEntr:=maxEntr;

                              IF maxEntr<22 THEN
                               BEGIN
                                    actScr:=maxEntr;
                               END
                              ELSE
                               BEGIN
                                    actScr:=21;

                                    FOR x:=1 TO 20 DO
                                     DrawList (actEntr-21+x,x,false);
                               END;

                              DrawList (actEntr,actScr,true);
                         END;
                        'G': { POS 1 }
                         BEGIN
                              DrawList (actEntr,actScr,false);
                              actScr:=1; actEntr:=1;

                              IF maxEntr>21 THEN
                               BEGIN
                                    FOR x:=2 TO 21 DO
                                     DrawList (x,x,false);
                               END;

                              DrawList (actEntr,actScr,true);
                         END;
                       END;

                  END;
            END;
     UNTIL done;
END;

begin
     GetScreen;
     GetCurXY;
     GetValues;
     BuildScreen;

     Run;

     SetCur;
     PutScreen;
end.




